#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>

#include "correlation.h"

#define N_SAMPLES 32
int main()
{
	int i, n = 2 * N_SAMPLES - 1;

	double x[] = {
		0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 2.0, 0.0,
		2.0, 0.0, 2.0, 0.0, 2.0, 0.0, 0.0, 0.0,
		0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
		0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
	};	

	double y[] = {
		2.0, 0.0, 2.0, 0.0, 2.0, 0.0, 2.0, 0.0,
		0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
		0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
		0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
	};
	
	double re_x[] = {
		0.0, 0.0, 0.0, 2.0,
		2.0, 2.0, 2.0, 0.0,
		0.0, 0.0, 0.0, 0.0,
		0.0, 0.0, 0.0, 0.0
	};

	double re_y[] = {
		2.0, 2.0, 2.0, 2.0,
		0.0, 0.0, 0.0, 0.0,
		0.0, 0.0, 0.0, 0.0,
		0.0, 0.0, 0.0, 0.0
	};
	
	double *out = NULL;
	double *slow_out = xcor_slow(re_y, N_SAMPLES / 2, re_x, N_SAMPLES / 2);
	
	out = malloc(N_SAMPLES * sizeof(double));
	
	FILE *fp1 = fopen("signal1.data", "w");
	FILE *fp2 = fopen("signal2.data", "w");
	FILE *fp3 = fopen("slow_xcor.data", "w");

	for (i = 0; i < N_SAMPLES ; i++) {
		if (i % 2 == 0) {
			fprintf(fp1, "%d %lf\n", i / 2, x[i]);
			fprintf(fp2, "%d %lf\n", i / 2, y[i]);
		}
	}
	
	for (i = 0; i < n; i++) {
		fprintf(fp3, "%d %lf\n", i, slow_out[i]);
		printf("%d %lf\n", i, slow_out[i]);
	}
	
	
	
	int res = xcor(x, N_SAMPLES, y, N_SAMPLES, out, N_SAMPLES);
	
	
	if (res < 0)
		return res;
	
	FILE *fp = fopen("out.data", "w");


	for (i = 0; i < N_SAMPLES ; i++) {
		printf("%d : %lf\n", i, out[i]);
		if (i % 2 == 0) {
			fprintf(fp, "%d %lf\n", i / 2 , out[i]);
		}
	}
	
	fclose(fp);
	fclose(fp1);
	fclose(fp2);
	fclose(fp3);
	
	execl("/bin/sh", "gnuplot","-c","gnuplot<plot.graph", NULL);
	
	free(out);
	free(slow_out);

	return 0;
}
